unit gfx_ArithmCtrl;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Buttons, ExtCtrls,gfx_rotresize,gfx_Effects;

type
  TArithCtrlForm = class(TForm)
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Label3: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Apply: TBitBtn;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Funct1: TListBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Button1: TButton;
    Label4: TLabel;
    Label5: TLabel;
    BitBtn1: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure Funct1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ApplyClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    DestBitmap:TBitmap;
    { Public-Deklarationen }
  end;

var
  ArithCtrlForm: TArithCtrlForm;

  const Functions:Array[0..10] of string =
      ('None',
       'Add',
       'Substract',
       'Multiply',
       'Divide',
       'Darkest',
       'Lightest',
       'Difference',
       'Binary Or',
       'Binary And',
       'Average');

implementation
uses pviewmain,pview_child;
{$R *.DFM}

procedure TArithCtrlForm.FormCreate(Sender: TObject);
var i:Integer;
begin
    DestBitmap:=TBitmap.Create;
    For i:=0 to 10 do Funct1.Items.Add(Functions[i]);
    for I:=0 To PViewMAinFrm.MDIChildCount -1 do
    begin
         ComboBox1.Items.Add(TPViewChild(PViewMAinFrm.MDIChildren[i]).FFileName);
         ComboBox2.Items.Add(TPViewChild(PViewMAinFrm.MDIChildren[i]).FFileName);
    end;
end;

procedure TArithCtrlForm.ComboBox1Change(Sender: TObject);
begin
 if not TPViewChild(PViewMAinFrm.MDIChildren[ComboBox1.ItemIndex]).ExtImage1.Image.Picture.Bitmap.Empty then
  StretchResize(TPViewChild(PViewMAinFrm.MDIChildren[ComboBox1.ItemIndex]).ExtImage1.Bitmap,
  Image1.Picture.Bitmap,Image1.Width,Image1.Height,false,clNone,True);
end;

procedure TArithCtrlForm.ComboBox2Change(Sender: TObject);
begin
 if not TPViewChild(PViewMAinFrm.MDIChildren[ComboBox2.ItemIndex]).ExtImage1.Bitmap.Empty then
  StretchResize(TPViewChild(PViewMAinFrm.MDIChildren[ComboBox2.ItemIndex]).ExtImage1.Bitmap,
  Image2.Picture.Bitmap,Image2.Width,Image2.Height,false,clNone,True);
end;

procedure TArithCtrlForm.Funct1Click(Sender: TObject);
procedure ClearBitmap(Bitmap:TBitmap);
begin
  Bitmap.Canvas.Brush.Color:=clWhite;
  Bitmap.Canvas.FillRect(Rect(0,0,Bitmap.Width,Bitmap.Height));
end;
begin
  ClearBitmap(Image3.Picture.Bitmap);
  EffectArithmetic(Image1.picture.bitmap,image2.picture.bitmap,image3.picture.bitmap,
  TGraphicArithmetic(Funct1.ItemIndex),
  nil);
  Image3.Repaint;
end;

procedure TArithCtrlForm.Button1Click(Sender: TObject);
procedure ClearBitmap(Bitmap:TBitmap);
begin
  Bitmap.Canvas.Brush.Color:=clWhite;
  Bitmap.Canvas.FillRect(Rect(0,0,Bitmap.Width,Bitmap.Height));
end;
begin
  ClearBitmap(Image3.Picture.Bitmap);
  EffectBlend(Image1.picture.bitmap,image2.picture.bitmap,image3.picture.bitmap,
  StrToInt(Edit2.Text),StrToInt(Edit1.Text), nil);
  Image3.Repaint;
end;

procedure TArithCtrlForm.ApplyClick(Sender: TObject);
begin
 Screen.Cursor:=crHourGlass;
 try
   if PageControl1.ActivePage = TabSheet1 then
    EffectArithmetic(TPViewChild(PViewMAinFrm.MDIChildren[ComboBox1.ItemIndex]).ExtImage1.Bitmap,
                     TPViewChild(PViewMAinFrm.MDIChildren[ComboBox2.ItemIndex]).ExtImage1.Bitmap,
                     DestBitmap,
                     TGraphicArithmetic(Funct1.ItemIndex),nil)
   else
   if PageControl1.ActivePage = TabSheet2 then
     EffectBlend(TPViewChild(PViewMAinFrm.MDIChildren[ComboBox1.ItemIndex]).ExtImage1.Bitmap,
                 TPViewChild(PViewMAinFrm.MDIChildren[ComboBox2.ItemIndex]).ExtImage1.Bitmap,
                 Destbitmap,
                 StrToInt(Edit2.Text),StrToInt(Edit1.Text), nil);
 finally
  Screen.Cursor:=crDefault;
 end;
end;

procedure TArithCtrlForm.FormDestroy(Sender: TObject);
begin
  DestBitmap.Free;
end;

end.
