unit gfx_EffectCtrl;
{***********************************************************************
Unit gfx_effectCtrl.PAS v1.0
    (c) by Andreas Moser, amoser@amoser.de,

    Delphi version : Delphi 4

    gfx_effectctrl is part of the gfx_library collection

    You may use this sourcecode for your freewareproducts.
    You may modify this source-code for your own use.
    You may recompile this source-code for your own use.

    All functions, procedures and classes may NOT be used in commercial
    products without the permission of the author. For parts of this library
    which are not written by me, you have to ask for permission by their
    respective authors.


    Disclaimer of warranty: "This software is supplied as is. The author
    disclaims all warranties, expressed or implied, including, without
    limitation, the warranties of merchantability and of fitness for any
    purpose. The author assumes no liability for damages, direct or
    consequential, which may result from the use of this software."

    All brand and product names are marks or registered marks of their
    respective companies.

    Please report bugs to:
    Andreas Moser  amoser@amoser.de

********************************************************************************}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, PreviewPanel,gfx_effects, Buttons, Spin,
  ExtTrackBar;

type
  TEffectCtrlForm = class(TForm)
    Label1: TLabel;
    TrackBar1: TTrackBar;
    Edit1: TEdit;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    PreviewPanel1: TPreviewPanel;
    RadioGroup1: TRadioGroup;
    Panel1: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    ExtTrackBar4: TExtTrackBar;
    ExtTrackBar5: TExtTrackBar;
    ExtTrackBar6: TExtTrackBar;
    ExtTrackBar1: TExtTrackBar;
    ExtTrackBar2: TExtTrackBar;
    ExtTrackBar3: TExtTrackBar;
    procedure TrackBar1Change(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure FormActivate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ExtTrackBar1Change(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    ResultBitmap:TBitmap;
    { Public-Deklarationen }
  end;

var
  EffectCtrlForm: TEffectCtrlForm;

implementation

{$R *.DFM}

procedure TEffectCtrlForm.TrackBar1Change(Sender: TObject);
begin
  Edit1.Text:=IntToStr(TrackBar1.Position);
  case RadioGroup1.ItemIndex of
  0:EffectSpray(PreviewPanel1.OriginalImage.Picture.Bitmap,PreviewPanel1.PreviewImage.Picture.Bitmap,Trackbar1.Position,nil);
  1:EffectAddNoise(PreviewPanel1.OriginalImage.Picture.Bitmap,PreviewPanel1.PreviewImage.Picture.Bitmap,Trackbar1.Position,true,nil);
  2:    EffectSinus(PreviewPanel1.OriginalImage.Picture.Bitmap,PreviewPanel1.PreviewImage.Picture.Bitmap,ExtTrackBar1.Position,ExtTrackBar2.Position,
    ExtTrackBar4.Position,ExtTrackBar5.Position,ExtTrackBar3.Position,ExtTrackBar6.Position,true,nil);

  end;
  PreviewPanel1.PreviewImage.Repaint;
end;

procedure TEffectCtrlForm.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if Key=#13 then begin
     TrackBar1.Position:=StrToInt(Edit1.Text);
  case RadioGroup1.ItemIndex of
  0:EffectSpray(PreviewPanel1.OriginalImage.Picture.Bitmap,PreviewPanel1.PreviewImage.Picture.Bitmap,Trackbar1.Position,nil);
  1:EffectAddNoise(PreviewPanel1.OriginalImage.Picture.Bitmap,PreviewPanel1.PreviewImage.Picture.Bitmap,Trackbar1.Position,true,nil);
  end;
  PreviewPanel1.PreviewImage.Repaint;
  end;
end;

procedure TEffectCtrlForm.FormActivate(Sender: TObject);
begin
  TrackBar1Change(self);
end;

procedure TEffectCtrlForm.BitBtn1Click(Sender: TObject);
begin
  Screen.Cursor:=crHourGlass;
  try
    if not PreviewPanel1.SourceBitmap.Empty then
    case RadioGroup1.ItemIndex of
    0:EffectSpray(PreviewPanel1.SourceBitmap,ResultBitmap,TrackBar1.Position,nil);
    1:EffectAddNoise(PreviewPanel1.SourceBitmap,ResultBitmap,TrackBar1.Position,true,nil);
    2:EffectSinus(PreviewPanel1.SourceBitmap,ResultBitmap,ExtTrackBar1.Position,ExtTrackBar2.Position,
    ExtTrackBar4.Position,ExtTrackBar5.Position,ExtTrackBar3.Position,ExtTrackBar6.Position,true,nil);
    end;
  finally
  Screen.Cursor:=crDefault;
  end;
end;

procedure TEffectCtrlForm.FormCreate(Sender: TObject);
begin
  ResultBitmap:=TBitmap.Create;
end;

procedure TEffectCtrlForm.ExtTrackBar1Change(Sender: TObject);
begin
    EffectSinus(PreviewPanel1.OriginalImage.Picture.Bitmap,PreviewPanel1.PreviewImage.Picture.Bitmap,ExtTrackBar1.Position,ExtTrackBar2.Position,
    ExtTrackBar4.Position,ExtTrackBar5.Position,ExtTrackBar3.Position,ExtTrackBar6.Position,true,nil);
    PreviewPanel1.PreviewImage.Repaint;
end;

procedure TEffectCtrlForm.RadioGroup1Click(Sender: TObject);
begin
  case RadioGroup1.ItemIndex of
  0:Panel1.Visible:=false;
  1:Panel1.Visible:=false;
  2:Panel1.Visible:=true;
  end;
end;


end.
